# Blur_Layer Class Reference

`#include <blur.h>`

Inheritance diagram for Blur_Layer:

List of all members.

## Public Member Functions

| Blur_Layer ()
virtual bool | set_param (const String &param, const synfig::ValueBase &value)
| Sets the parameter described by param to value.
virtual ValueBase | get_param (const String &param) const
| Get the value of the specified parameter.
virtual Color | get_color (Context context, const Point &pos) const
| Gets the color of the Canvas at pos.
virtual bool | accelerated_render (Context context, Surface *surface, int quality, const RendDesc &renddesc, ProgressCallback *cb) const
| Renders the Canvas to the given Surface in an accelerated manner.
virtual synfig::Rect | get_full_bounding_rect (Context context) const
virtual Vocab | get_param_vocab () const
| Gets the parameter vocabulary.
virtual bool | reads_context () const
| Returns true if the layer needs to be able to examine its context.

## Constructor & Destructor Documentation

Blur_Layer::Blur_Layer | ( |  | ) |

## Member Function Documentation

bool Blur_Layer::set_param | ( | const String & | param,
|  | const synfig::ValueBase & | value |
| ) |  |  | `[virtual]`

Sets the parameter described by param to value.

Parameters:

  | param | The name of the parameter to set
  | value | What the parameter is to be set to.

Returns:
  `true` on success, `false` upon rejection or failure. If it returns `false`, then the Layer is assumed to remain unchanged.

See also:
  get_param()

Todo:
  param should be of the type `const String &param`

Reimplemented from synfig::Layer_Composite.

References clamp(), IMPORT, and IMPORT_PLUS.

ValueBase Blur_Layer::get_param | ( | const String & | param | ) | const`[virtual]`

Get the value of the specified parameter.

Returns:
  The requested parameter value, or (upon failure) a NIL ValueBase.

See also:
  set_param()

Todo:
  param should be of the type `const String &`

Reimplemented from synfig::Layer_Composite.

References EXPORT, EXPORT_NAME, and EXPORT_VERSION.

Color Blur_Layer::get_color | ( | Context | context,
|  | const Point & | pos |
| ) |  |  | const`[virtual]`

Gets the color of the Canvas at pos.

Parameters:

  | context | Context iterator referring to next Layer.
  | pos | Point which indicates where the Color should come from

See also:
  Handle::get_color()

Reimplemented from synfig::Layer.

References synfig::Layer_Composite::get_amount(), synfig::Layer_Composite::get_blend_method(), and synfig::Context::get_color().

bool Blur_Layer::accelerated_render | ( | Context | context,
|  | Surface * | surface,
|  | int | quality,
|  | const RendDesc & | renddesc,
|  | ProgressCallback * | cb |
| ) |  |  | const`[virtual]`

Renders the Canvas to the given Surface in an accelerated manner.

Parameters:

  | context | Context iterator referring to next Layer.
  | surface | Pointer to Surface to render to.
  | quality | The requested quality-level to render at.
  | renddesc | The associated RendDesc.
  | cb | Pointer to callback object. May be NULL if there is no callback.

Returns:
  `true` on success, `false` on failure

See also:
  Handle::accelerated_render()

Reimplemented from synfig::Layer_Composite.

References std::abs(), synfig::Context::accelerated_render(), synfig::ProgressCallback::amount_complete(), synfig::Surface::blit_to(), Blur::BOX, Blur::CROSS, Blur::DISC, Blur::FASTGAUSSIAN, Blur::GAUSSIAN, GAUSSIAN_ADJUSTMENT, synfig::Layer_Composite::get_amount(), synfig::Layer_Composite::get_blend_method(), synfig::RendDesc::get_br(), synfig::RendDesc::get_h(), synfig::RendDesc::get_ph(), synfig::RendDesc::get_pw(), synfig::RendDesc::get_tl(), synfig::RendDesc::get_w(), and synfig::RendDesc::set_subwindow().

Rect Blur_Layer::get_full_bounding_rect | ( | Context | context | ) | const`[virtual]`

Reimplemented from synfig::Layer_Composite.

References synfig::Rect::expand_x(), synfig::Rect::expand_y(), synfig::Layer_Composite::get_blend_method(), synfig::Context::get_full_bounding_rect(), and synfig::Layer_Composite::is_disabled().

Layer::Vocab Blur_Layer::get_param_vocab | ( | void |  | ) | const`[virtual]`

Gets the parameter vocabulary.

Reimplemented from synfig::Layer_Composite.

References _, Blur::BOX, Blur::CROSS, Blur::DISC, Blur::FASTGAUSSIAN, Blur::GAUSSIAN, and synfig::Layer::set_description().

virtual bool Blur_Layer::reads_context | ( |  | ) | const`[inline, virtual]`

Returns true if the layer needs to be able to examine its context.

context to render itself, other than for simple blending. For example, the blur layer will return true - it can't do its job if it can't see its context, and the circle layer will return false - rendering a circle doesn't depend on the underlying context until the final blend operation.

Reimplemented from synfig::Layer.

The documentation for this class was generated from the following files:

- modules/mod_filter/blur.h
- modules/mod_filter/blur.cpp